// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.administration.user.ageReader;

/**
 * <p>
 * Un lecteur d’âge (Person) peut avoir différents niveaux de
 * qualification (AgeReaderQualification). Un niveau de
 * qualification est limité dans le temps, par une période
 * début/fin (la date de fin peut être vide si la qualification est
 * toujours d’actualité).
 * </p>
 * <p>
 * Un niveau de qualification est constitué par une valeur entière
 * positive (qualificationLevel) qui représente le pourcentage de
 * réussite de lecture reconnu du lecteur.
 * </p>
 * <p>
 * Un niveau de qualification s’applique à une espèce scientifique
 * (ReferenceTaxon, de niveau espèce ou sous-espèce seulement, ou
 * bien genre, famille,  etc .) et une ou plusieurs zones en mer
 * (Location). Les zones en mer peuvent être des zones FAO, sous
 * zones FAO, divisions, sous divisions, rectangles, etc.
 * </p>
 */
public abstract class AgeReaderQualification
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -167617262123227208L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant interne. généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.util.Date startDate;

    /**
     * 
     */
    public java.util.Date getStartDate()
    {
        return this.startDate;
    }

    public void setStartDate(java.util.Date startDate)
    {
        this.startDate = startDate;
    }

    private java.util.Date endDate;

    /**
     * 
     */
    public java.util.Date getEndDate()
    {
        return this.endDate;
    }

    public void setEndDate(java.util.Date endDate)
    {
        this.endDate = endDate;
    }

    private java.lang.Integer qualificationLevel;

    /**
     * 
     */
    public java.lang.Integer getQualificationLevel()
    {
        return this.qualificationLevel;
    }

    public void setQualificationLevel(java.lang.Integer qualificationLevel)
    {
        this.qualificationLevel = qualificationLevel;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.administration.user.Person> people = new java.util.HashSet<fr.ifremer.adagio.core.dao.administration.user.Person>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.administration.user.Person> getPeople()
    {
        return this.people;
    }

    public void setPeople(java.util.Collection<fr.ifremer.adagio.core.dao.administration.user.Person> people)
    {
        this.people = people;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> locations = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.location.Location>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> getLocations()
    {
        return this.locations;
    }

    public void setLocations(java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> locations)
    {
        this.locations = locations;
    }


    private fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    public void setReferenceTaxon(fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon)
    {
        this.referenceTaxon = referenceTaxon;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof AgeReaderQualification))
        {
            return false;
        }
        final AgeReaderQualification that = (AgeReaderQualification)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification}.
         */
        public static fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification newInstance()
        {
            final fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification entity = new fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualificationImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification newInstance(java.util.Date startDate, java.lang.Integer qualificationLevel, java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> locations, fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon)
        {
            final fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification entity = newInstance();
            entity.setStartDate(startDate);
            entity.setQualificationLevel(qualificationLevel);
            entity.setLocations(locations);
            entity.setReferenceTaxon(referenceTaxon);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification newInstance(java.util.Date startDate, java.util.Date endDate, java.lang.Integer qualificationLevel, java.util.Collection<fr.ifremer.adagio.core.dao.administration.user.Person> people, java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.Location> locations, fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon)
        {
            final fr.ifremer.adagio.core.dao.administration.user.ageReader.AgeReaderQualification entity = newInstance();
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setQualificationLevel(qualificationLevel);
            entity.setPeople(people);
            entity.setLocations(locations);
            entity.setReferenceTaxon(referenceTaxon);
            return entity;
        }
    }
    
// AgeReaderQualification.java merge-point
}