// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.survey.sale;

/**
 * <p>
 * Vente liée à un navire, effectuée en un lieu et une date
 * données. Une vente regroupe plusieurs produits vendus (Produce).
 * </p>
 * <p>
 * Attention : une vente est ponctuelle dans le temps. Si l'on
 * souhaite recencer une vente qui s'étale sur plusieurs jours,
 * </p>
 */
public abstract class Sale
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8081463357582260532L;

    private java.lang.Integer id;

    /**
     * <p>
     * Idenfiant interne. Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.util.Date saleStartDate;

    /**
     * <p>
     * Date de vente, ou date de début de la vente si la période de
     * vente est connue (ex : déclaration de vente mensuelle des
     * viviers).
     * </p>
     */
    public java.util.Date getSaleStartDate()
    {
        return this.saleStartDate;
    }

    public void setSaleStartDate(java.util.Date saleStartDate)
    {
        this.saleStartDate = saleStartDate;
    }

    private java.util.Date saleEndDate;

    /**
     * <p>
     * Date de fin de la vente (Optionnel). Si non renseigné, signifie
     * que la période de la vente n'est pas connue ou que la vente est
     * très ponctuelle dans le temps.
     * </p>
     * <p>
     * NE PAS RENSEIGNER pour les ventes ponctuelles, sur une journée.
     * </p>
     */
    public java.util.Date getSaleEndDate()
    {
        return this.saleEndDate;
    }

    public void setSaleEndDate(java.util.Date saleEndDate)
    {
        this.saleEndDate = saleEndDate;
    }

    private java.lang.String synchronizationStatus;

    /**
     * 
     */
    public java.lang.String getSynchronizationStatus()
    {
        return this.synchronizationStatus;
    }

    public void setSynchronizationStatus(java.lang.String synchronizationStatus)
    {
        this.synchronizationStatus = synchronizationStatus;
    }

    private java.lang.String comments;

    /**
     * 
     */
    public java.lang.String getComments()
    {
        return this.comments;
    }

    public void setComments(java.lang.String comments)
    {
        this.comments = comments;
    }

    private java.util.Date creationDate;

    /**
     * 
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.util.Date controlDate;

    /**
     * 
     */
    public java.util.Date getControlDate()
    {
        return this.controlDate;
    }

    public void setControlDate(java.util.Date controlDate)
    {
        this.controlDate = controlDate;
    }

    private java.util.Date validationDate;

    /**
     * 
     */
    public java.util.Date getValidationDate()
    {
        return this.validationDate;
    }

    public void setValidationDate(java.util.Date validationDate)
    {
        this.validationDate = validationDate;
    }

    private java.util.Date qualificationDate;

    /**
     * 
     */
    public java.util.Date getQualificationDate()
    {
        return this.qualificationDate;
    }

    public void setQualificationDate(java.util.Date qualificationDate)
    {
        this.qualificationDate = qualificationDate;
    }

    private java.lang.String qualificationComments;

    /**
     * 
     */
    public java.lang.String getQualificationComments()
    {
        return this.qualificationComments;
    }

    public void setQualificationComments(java.lang.String qualificationComments)
    {
        this.qualificationComments = qualificationComments;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SaleMeasurement> saleMeasurements = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.measure.SaleMeasurement>();

    /**
     * <p>
     * Caractéristiques sur la vente (données economiques, ou
     * caractéristiques de l'observation, etc.).
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SaleMeasurement> getSaleMeasurements()
    {
        return this.saleMeasurements;
    }

    public void setSaleMeasurements(java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SaleMeasurement> saleMeasurements)
    {
        this.saleMeasurements = saleMeasurements;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement>();

    /**
     * <p>
     * Caractéristiques de l'enquete.
     * </p>
     * <p>
     * Par exemple : qualification d'une enquête sur un navire.
     * </p>
     * <p>
     * Permet de qualifier les enquetes en :
     * </p>
     * <p>
     * - Enquête Directe
     * </p>
     * <p>
     * - Enquête Indirecte
     * </p>
     * <p>
     * - Estimation
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> getSurveyMeasurements()
    {
        return this.surveyMeasurements;
    }

    public void setSurveyMeasurements(java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements)
    {
        this.surveyMeasurements = surveyMeasurements;
    }



    private fr.ifremer.adagio.core.dao.data.batch.CatchBatch catchBatch;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.batch.CatchBatch getCatchBatch()
    {
        return this.catchBatch;
    }

    public void setCatchBatch(fr.ifremer.adagio.core.dao.data.batch.CatchBatch catchBatch)
    {
        this.catchBatch = catchBatch;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.produce.Produce>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> getProduces()
    {
        return this.produces;
    }

    public void setProduces(java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces)
    {
        this.produces = produces;
    }


    private fr.ifremer.adagio.core.dao.data.survey.landing.Landing landing;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.landing.Landing getLanding()
    {
        return this.landing;
    }

    public void setLanding(fr.ifremer.adagio.core.dao.data.survey.landing.Landing landing)
    {
        this.landing = landing;
    }


    private fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference declaredDocumentReference;

    /**
     * <p>
     * Reference du document déclaratif ayant servi à renseigner la
     * vente.
     * </p>
     * <p>
     * Exemple : vente RIC.
     * </p>
     */
    public fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference getDeclaredDocumentReference()
    {
        return this.declaredDocumentReference;
    }

    public void setDeclaredDocumentReference(fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference declaredDocumentReference)
    {
        this.declaredDocumentReference = declaredDocumentReference;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.SaleOrigin> saleOrigins = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.survey.sale.SaleOrigin>();

    /**
     * <p>
     * org.eclipse.uml2.impl.CommentImpl@1f9a5d5 (body: )
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.SaleOrigin> getSaleOrigins()
    {
        return this.saleOrigins;
    }

    public void setSaleOrigins(java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.SaleOrigin> saleOrigins)
    {
        this.saleOrigins = saleOrigins;
    }


    private fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.vessel.Vessel getVessel()
    {
        return this.vessel;
    }

    public void setVessel(fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel)
    {
        this.vessel = vessel;
    }


    private fr.ifremer.adagio.core.dao.referential.seller.Seller seller;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.seller.Seller getSeller()
    {
        return this.seller;
    }

    public void setSeller(fr.ifremer.adagio.core.dao.referential.seller.Seller seller)
    {
        this.seller = seller;
    }


    private fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    public void setQualityFlag(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag)
    {
        this.qualityFlag = qualityFlag;
    }


    private fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.user.Person getRecorderPerson()
    {
        return this.recorderPerson;
    }

    public void setRecorderPerson(fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson)
    {
        this.recorderPerson = recorderPerson;
    }


    private fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.user.Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    public void setRecorderDepartment(fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment)
    {
        this.recorderDepartment = recorderDepartment;
    }


    private fr.ifremer.adagio.core.dao.administration.programStrategy.Program program;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.administration.programStrategy.Program getProgram()
    {
        return this.program;
    }

    public void setProgram(fr.ifremer.adagio.core.dao.administration.programStrategy.Program program)
    {
        this.program = program;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location saleLocation;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getSaleLocation()
    {
        return this.saleLocation;
    }

    public void setSaleLocation(fr.ifremer.adagio.core.dao.referential.location.Location saleLocation)
    {
        this.saleLocation = saleLocation;
    }


    private fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    public void setFishingTrip(fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip)
    {
        this.fishingTrip = fishingTrip;
    }


    private fr.ifremer.adagio.core.dao.referential.SaleType saleType;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.SaleType getSaleType()
    {
        return this.saleType;
    }

    public void setSaleType(fr.ifremer.adagio.core.dao.referential.SaleType saleType)
    {
        this.saleType = saleType;
    }


    private fr.ifremer.adagio.core.dao.data.survey.takeOver.TakeOver takeOver;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.takeOver.TakeOver getTakeOver()
    {
        return this.takeOver;
    }

    public void setTakeOver(fr.ifremer.adagio.core.dao.data.survey.takeOver.TakeOver takeOver)
    {
        this.takeOver = takeOver;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> fishingAreas = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea>();

    /**
     * <p>
     * <html>
     * </p>
     * <p>
     * <head>
     * </p>
     * <p>
     * <style>
     * </p>
     * <p>
     * p {padding:0px; margin:0px;}
     * </p>
     * <p>
     * </style>
     * </p>
     * <p>
     * </head>
     * </p>
     * <p>
     * <body>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Zones de pêche liées à la vente.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * =&gt; Il faut utiliser de préférence Produce.fishingArea, plus
     * facile à
     * </p>
     * <p>
     * exploiter car Produce est lié à l'espèce commerciale.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Ce lien vers FishingArea a été nécessaire pour Allegro, afin de
     * stocker
     * </p>
     * <p>
     * les zones de pêche récupérée dans WAO, à partir d'une référence
     * de plan
     * </p>
     * <p>
     * d'échantillonnage.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * </body>
     * </p>
     * <p>
     * </html>
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> getFishingAreas()
    {
        return this.fishingAreas;
    }

    public void setFishingAreas(java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> fishingAreas)
    {
        this.fishingAreas = fishingAreas;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Sale))
        {
            return false;
        }
        final Sale that = (Sale)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.survey.sale.Sale}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.survey.sale.Sale}.
         */
        public static fr.ifremer.adagio.core.dao.data.survey.sale.Sale newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.survey.sale.Sale entity = new fr.ifremer.adagio.core.dao.data.survey.sale.SaleImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.survey.sale.Sale}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.survey.sale.Sale newInstance(java.util.Date saleStartDate, java.lang.String synchronizationStatus, java.util.Date creationDate, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, fr.ifremer.adagio.core.dao.referential.location.Location saleLocation, fr.ifremer.adagio.core.dao.referential.SaleType saleType)
        {
            final fr.ifremer.adagio.core.dao.data.survey.sale.Sale entity = newInstance();
            entity.setSaleStartDate(saleStartDate);
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setCreationDate(creationDate);
            entity.setVessel(vessel);
            entity.setQualityFlag(qualityFlag);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setProgram(program);
            entity.setSaleLocation(saleLocation);
            entity.setSaleType(saleType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.survey.sale.Sale}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.survey.sale.Sale newInstance(java.util.Date saleStartDate, java.util.Date saleEndDate, java.lang.String synchronizationStatus, java.lang.String comments, java.util.Date creationDate, java.util.Date controlDate, java.util.Date validationDate, java.util.Date qualificationDate, java.lang.String qualificationComments, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SaleMeasurement> saleMeasurements, java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.SurveyMeasurement> surveyMeasurements, fr.ifremer.adagio.core.dao.data.batch.CatchBatch catchBatch, java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces, fr.ifremer.adagio.core.dao.data.survey.landing.Landing landing, fr.ifremer.adagio.core.dao.data.survey.declaration.DeclaredDocumentReference declaredDocumentReference, java.util.Collection<fr.ifremer.adagio.core.dao.data.survey.sale.SaleOrigin> saleOrigins, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.referential.seller.Seller seller, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.administration.user.Person recorderPerson, fr.ifremer.adagio.core.dao.administration.user.Department recorderDepartment, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, fr.ifremer.adagio.core.dao.referential.location.Location saleLocation, fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip, fr.ifremer.adagio.core.dao.referential.SaleType saleType, fr.ifremer.adagio.core.dao.data.survey.takeOver.TakeOver takeOver, java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> fishingAreas)
        {
            final fr.ifremer.adagio.core.dao.data.survey.sale.Sale entity = newInstance();
            entity.setSaleStartDate(saleStartDate);
            entity.setSaleEndDate(saleEndDate);
            entity.setSynchronizationStatus(synchronizationStatus);
            entity.setComments(comments);
            entity.setCreationDate(creationDate);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setUpdateDate(updateDate);
            entity.setSaleMeasurements(saleMeasurements);
            entity.setSurveyMeasurements(surveyMeasurements);
            entity.setCatchBatch(catchBatch);
            entity.setProduces(produces);
            entity.setLanding(landing);
            entity.setDeclaredDocumentReference(declaredDocumentReference);
            entity.setSaleOrigins(saleOrigins);
            entity.setVessel(vessel);
            entity.setSeller(seller);
            entity.setQualityFlag(qualityFlag);
            entity.setRecorderPerson(recorderPerson);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setProgram(program);
            entity.setSaleLocation(saleLocation);
            entity.setFishingTrip(fishingTrip);
            entity.setSaleType(saleType);
            entity.setTakeOver(takeOver);
            entity.setFishingAreas(fishingAreas);
            return entity;
        }
    }
    
// Sale.java merge-point
}