// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.location;

/**
 * <p>
 * Niveau de lieu, ou catégorie. Il s'agit d'un regroupement de
 * haut niveau d'un ensemble de lieux de meme nature géographique.
 * </p>
 * <p>
 * Par exemple, pour la classification de lieu "Secteur maritime",
 * on aura :
 * </p>
 * <p>
 * - Zone FAO,
 * </p>
 * <p>
 * - Sous-Zone FAO,
 * </p>
 * <p>
 * - Division CIEM,
 * </p>
 * <p>
 * - Sous-division CIEM
 * </p>
 * <p>
 * - etc.
 * </p>
 * <p>
 * Pour la classification de lieu "lieux territoriaux", on aura :
 * </p>
 * <p>
 * - Pays
 * </p>
 * <p>
 * - Region,
 * </p>
 * <p>
 * - Département,
 * </p>
 * <p>
 * - Quartier Maritme,
 * </p>
 * <p>
 * - Port
 * </p>
 * <p>
 * - ...
 * </p>
 * <p>
 * On pourra trouver d'autre niveau de lieu, comme :
 * </p>
 * <p>
 * - implantation Ifremer
 * </p>
 * <p>
 * - laboratoire côtier, ...
 * </p>
 */
public abstract class LocationLevel
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2620804644117218001L;

    private java.lang.Integer id;

    /**
     * <p>
     * Idenfiant interne.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String name;

    /**
     * 
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationLevel> locationLevels = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.location.LocationLevel>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationLevel> getLocationLevels()
    {
        return this.locationLevels;
    }

    public void setLocationLevels(java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationLevel> locationLevels)
    {
        this.locationLevels = locationLevels;
    }


    private fr.ifremer.adagio.core.dao.referential.location.LocationLevel parentLocationLevel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.location.LocationLevel getParentLocationLevel()
    {
        return this.parentLocationLevel;
    }

    public void setParentLocationLevel(fr.ifremer.adagio.core.dao.referential.location.LocationLevel parentLocationLevel)
    {
        this.parentLocationLevel = parentLocationLevel;
    }



    private fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.location.LocationClassification getLocationClassification()
    {
        return this.locationClassification;
    }

    public void setLocationClassification(fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification)
    {
        this.locationClassification = locationClassification;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof LocationLevel))
        {
            return false;
        }
        final LocationLevel that = (LocationLevel)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.location.LocationLevel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.location.LocationLevel}.
         */
        public static fr.ifremer.adagio.core.dao.referential.location.LocationLevel newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.location.LocationLevel entity = new fr.ifremer.adagio.core.dao.referential.location.LocationLevelImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.location.LocationLevel}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.location.LocationLevel newInstance(java.lang.String name, fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification)
        {
            final fr.ifremer.adagio.core.dao.referential.location.LocationLevel entity = newInstance();
            entity.setName(name);
            entity.setLocationClassification(locationClassification);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.location.LocationLevel}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.location.LocationLevel newInstance(java.lang.String name, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.location.LocationLevel> locationLevels, fr.ifremer.adagio.core.dao.referential.location.LocationLevel parentLocationLevel, fr.ifremer.adagio.core.dao.referential.location.LocationClassification locationClassification)
        {
            final fr.ifremer.adagio.core.dao.referential.location.LocationLevel entity = newInstance();
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setLocationLevels(locationLevels);
            entity.setParentLocationLevel(parentLocationLevel);
            entity.setLocationClassification(locationClassification);
            return entity;
        }
    }
    
// LocationLevel.java merge-point
}